/*********************************************************************
 *  ÓdeʎZVO  
 *                        << CPSJEg \ >>@
 * 
 *      1 VDD         8 VSS
 *  LED 2 RA5         7 RA0 TX
 * CPS3 3 RA4         6 RA1 LED
 *      4 MCLR        5 RA2 CPS2
 * 
 * PIC12F1822  MPLAB X IDE with XC8 Ver1.32
 * Copyright (c) 2014 iwamoto All Rights Reserved

 * *******************************************************************
 * Enable_Dsp LɂACPS index (0 or 1)LƁA
 * Avg  rawJEglLCDUARTMB
 * *******************************************************************/
#define Enable_Dsp 1      // LCDڑȂƂ͂̍sRgAEg

#define ch_0_IN    2      // CPS index0 Pad ڑ CPS [qԍ
#define ch_1_IN    3      // CPS index1 Pad ڑ CPS [qԍ
#define ch_0_OUT   LATA1  // CPS index0 LED ڑ |[g
#define ch_1_OUT   LATA5  // CPS index1 LED ڑ |[g
#define LED_ON     1
#define LED_OFF    0

#define _XTAL_FREQ 4000000 // delay_ms(x) ̂߂̒`

#include <xc.h>
#include <stdio.h>
#include <stdlib.h>

//******************* RtBO[V ****************************
#pragma config FOSC = INTOSC, WDTE = OFF, PWRTE = OFF, MCLRE = OFF, CP = OFF
#pragma config CPD = OFF, BOREN = ON, CLKOUTEN = OFF, IESO = OFF, FCMEN = OFF
#pragma config WRT = OFF, PLLEN = OFF, STVREN = ON, BORV = LO, LVP = OFF
//
//******************* vg^Cv ****************************
void CPSck(char);
unsigned int CPScnt(char);
void LEDout(char, char);
//******************* ʕϐ ****************************
char ch_IN[] = {ch_0_IN, ch_1_IN};  // CPS [qԍ
unsigned int Avg[2];                // ʏ펞σJEg
unsigned int swOn[]  = {180,180};   // ON  臒lσJEg
unsigned int swOff[] = { 90, 90};   // OFF 臒lσJEg

#ifdef Enable_Dsp
// ================= printf֐gp邽߂̒` =================
void putch(unsigned char ch) {
    while (!TXIF);                  //MI҂
        TXREG = ch;                 //ꕶM
}
#endif

// ******************* main ******************************************
void main() {
    OSCCON = 0b01101010;            //  NbN4Mhz
    PORTA  = 0x00; 
    TRISA  = 0b11011101;            // RA1:LEDo ͓
    ANSELA = 0b00010100;            // RA2:CPS, fW^
    WPUA   = 0b00001000;            // RA3 vAbv ON
    OPTION_REGbits.nWPUEN = 0;

    // Timer 0 ݒ ------------------------------------------
    //   8.2mSŃI[o[t[ACPSJEg̃^Cx[XƂȂ
    // -------------------------------------------------------A
    OPTION_REGbits.TMR0CS = 0;      // NbNJEg
    OPTION_REGbits.PSA = 0;         // vXPgp
    OPTION_REGbits.PS = 4;          // PS_1:32

    // Timer 1 ݒ -------------------------------------------------
    //   Gate@\ VOgO@[h
    //   CPS JEg
    // --------------------------------------------------------------A
    T1CON  = 0b11000001;       // CAPOSC, PS 1:1, OSC, , ON
    T1GCON = 0b11110001;       // GateL, ɐ, gO, VO, T0

    // CPS ݒ ------------------------------------------------------
    CPSCON0 = 0b10001000;      // CPSL, QƓd, Medium W
    // ʏ펞σJEg̏ݒ -------------------------------------
    Avg[0] = CPScnt(0); 
    Avg[1] = CPScnt(1);
    
#ifdef Enable_Dsp
    // UARTi\jݒ -------------------------------
    RCSTA   = 0b10000000;      // 񓯊M 9600baud
    TXSTA   = 0b00100100;
    BAUDCON = 0b00001000;
    SPBRGH  = 0;     
    SPBRG   = 103;
    __delay_ms(500);           // LCD肷܂ő҂
    printf("\x01");            // LCD SNA
#endif
    
    while(1){
        CPSck(0);              // CPS index0 ̏
        CPSck(1);              // CPS index1 ̏
    }
}

/*************************************************************
 * w CPS index`l̃JEgvA
 * ʏ펞σJEgƔr
 *      ON 臒l菬΁ALED@ON
 *      OFF臒l傫΁ALED OFF@
 *                            ϒlXV
 *************************************************************/
void CPSck(char ch){
    unsigned int raw;
    raw = CPScnt(ch);                        // `l̃JEgv
    if(raw < (Avg[ch] - swOn[ch])){          // ON 臒l菬
        LEDout(LED_ON, ch);                  //   LED@ON
    }else if(raw > (Avg[ch] - swOff[ch])){   // OFF臒l傫
        LEDout(LED_OFF, ch);                 //   LED OFF
        // ϒlXV id 1/16j
        Avg[ch] = Avg[ch] + ((long)raw - (long)Avg[ch])/ 16;
    }
#ifdef Enable_Dsp
    if(Enable_Dsp != ch)return;     // w`l͈ȉ{
    printf("\x02");                 // i擪ɃJ[\
    printf("%6d",Avg[ch]);          // avg l \
    printf("\x03");                 // i擪ɃJ[\
    printf("%6d",raw);              // Timer1 l \
    __delay_ms(100);
#endif
}
/**************************************************************
 * w CPS index`l̃JEg
 * v
 *************************************************************/
unsigned int CPScnt(char ch){
    CPSCON1 = ch_IN[ch];            // CPS index`lw
    TMR0 = 0xFE;                    //  Timer0 n
    TMR1H = 0;                      //  Timer1 NA
    TMR1L = 0;                      //
    T1GGO  = 1;                     // vw
    while(T1GGO);                   // vI҂
    return ((TMR1H << 8) | TMR1L);  // Timer1ǎ
}
/**************************************************************
 * w CPS index`lLED
 * ON / OFF
 *************************************************************/
void LEDout(char OnOff, char ch){
    switch(ch){
        case 0: ch_0_OUT = OnOff;break;
        case 1: ch_1_OUT = OnOff;break;
    }
}
